VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 2  'RequiresTransaction
END
Attribute VB_Name = "Title"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' addNewTitle
'
' Adds new title
' Using MTS transactions to commit or rollback all changes
Public Sub addNewTitle()
   'Declare object variables for the database connection and recordset
   Dim cn As Connection
   Dim cmnd As Command
   Dim cmnd2 As Command

   ' create ASP Response object
   Dim objContext As ObjectContext
   Dim objRequest As Request

   Set objContext = GetObjectContext()
   
   ' create ASP objects
   Set objRequest = objContext.Item("Request")
   
   On Error GoTo HandleError
   
   ' connect to database
   Set cn = objContext.CreateInstance("ADODB.Connection")
   cn.ConnectionString = "driver={SQL Server};server=FLAME;uid=sa;pwd=;database=pubs"
   cn.Open
   
   ' create command objects, connect
   Set cmnd = objContext.CreateInstance("ADODB.Command")
   Set cmnd2 = objContext.CreateInstance("ADODB.Command")
   
   Set cmnd.ActiveConnection = cn
   Set cmnd2.ActiveConnection = cn
   
   
   ' set parameters for stored procedure
   cmnd.Parameters.Append cmnd.CreateParameter("title_id", adVarChar, _
    adParamInput, 6, objRequest.Form.Item("id"))
       
   cmnd.Parameters.Append cmnd.CreateParameter("title", adVarChar, _
       adParamInput, 80, objRequest.Form.Item("title"))
       
   cmnd.Parameters.Append cmnd.CreateParameter("type", adChar, _
      adParamInput, 12, objRequest.Form.Item("booktype"))
   
   cmnd.Parameters.Append cmnd.CreateParameter("pub_id", adChar, _
      adParamInput, 4, objRequest.Form.Item("publisher"))
   
   cmnd.Parameters.Append cmnd.CreateParameter("price", adCurrency, _
      adParamInput, 8, objRequest.Form.Item("price"))
   
   cmnd.Parameters.Append cmnd.CreateParameter("advance", adCurrency, _
      adParamInput, 8, objRequest.Form.Item("advance"))
   
   cmnd.Parameters.Append cmnd.CreateParameter("royalty", adInteger, _
      adParamInput, 4, objRequest.Form.Item("royalty"))
   
   cmnd.Parameters.Append cmnd.CreateParameter("ytd", adInteger, _
     adParamInput, 4, objRequest.Form.Item("ytd"))
   
   cmnd.Parameters.Append cmnd.CreateParameter("notes", adVarChar, _
    adParamInput, 200, objRequest.Form.Item("notes"))
   
   cmnd.Parameters.Append cmnd.CreateParameter("pubdate", adDBTimeStamp, _
    adParamInput, 8, objRequest.Form.Item("pubdate"))
   
   
   ' set stored procedure
   cmnd.CommandText = "sp_insert_titles_1"
   cmnd.CommandType = adCmdStoredProc
   
   ' execute sp
   cmnd.Execute
   
   ' add the royalty item, using same transaction
   ' set parameters for stored procedure
   cmnd2.Parameters.Append cmnd2.CreateParameter("title_id", adVarChar, _
    adParamInput, 6, objRequest.Form.Item("id"))
       
   cmnd2.Parameters.Append cmnd2.CreateParameter("lorange", adInteger, _
    adParamInput, , 0)
       
   cmnd2.Parameters.Append cmnd2.CreateParameter("type", adInteger, _
    adParamInput, , 10000)
   
   cmnd2.Parameters.Append cmnd2.CreateParameter("pub_id", adInteger, _
    adParamInput, , objRequest.Form.Item("royalty"))
   
   ' set stored procedure
   cmnd2.CommandText = "sp_insert_roysched_1"
   cmnd2.CommandType = adCmdStoredProc
   
   ' start transaction
   cmnd2.Execute
      
   cn.Close
   
   objContext.SetComplete
HandleError:
    If Err.Number <> 0 Then
        objContext.SetAbort
        Err.Raise Err.Number, Err.Source, Err.Description
    End If

End Sub

' getTypes
'
Public Function getTypes() As Recordset

   'Declare object variables for the database connection and recordset
   Dim cn As New Connection
   Dim rs As New Recordset

   ' add error handler
   On Error GoTo HandleError
            
   ' connect to database
   cn.ConnectionString = "driver={SQL Server};server=FLAME;uid=sa;pwd=;database=pubs"
   cn.Open
   
   Set rs.ActiveConnection = cn
   rs.CursorLocation = adUseClient
   rs.Source = "select distinct(type) from titles"
   
   rs.Open
   
   ' disconnect recordset
   Set rs.ActiveConnection = Nothing
   cn.Close
   
   ' return disconnected recordset
   Set getTypes = rs
   
' print out any error message
HandleError:
    If Err.Number <> 0 Then
       Err.Raise Err.Number, Err.Source, Err.Description
    End If


End Function

' deleteTitle
' Deletes specific title
' Uses MTS transaction to commit or rollback changes
Public Sub deleteTitle()

   'Declare object variables for the database connection and recordset
   Dim cn As Connection
   Dim cmnd As Command
   Dim objRequest As Request
   Dim objResponse As Response
   
   Dim objContext As ObjectContext
   Set objContext = GetObjectContext()
   
   ' create ASP objects
   Set objRequest = objContext.Item("Request")
   
   On Error GoTo HandleError

   ' connect to database
   Set cn = objContext.CreateInstance("ADODB.Connection")
   cn.ConnectionString = "driver={SQL Server};server=FLAME;uid=sa;pwd=;database=pubs"
   cn.Open
   
   ' set connection
   Set cmnd = objContext.CreateInstance("ADODB.Command")
   Set cmnd.ActiveConnection = cn

   ' set parameters for stored procedure
   cmnd.Parameters.Append cmnd.CreateParameter("title_id_1", _
   adVarChar, adParamInput, 6, objRequest.Form.Item("titleid"))

   ' set stored procedure
   cmnd.CommandText = "sp_delete_titles_1"
   cmnd.CommandType = adCmdStoredProc
   
   ' execute sp
   cmnd.Execute
   
   cn.Close
   objContext.SetComplete
HandleError:
    If Err.Number <> 0 Then
        objContext.SetAbort
        Err.Raise Err.Number, Err.Source, Err.Description
    End If

End Sub

' getTitles
'
' return recordset with titles
' using disconnected recordsets
Public Function getTitles() As ADODB.Recordset

   'Declare object variables for the database connection and recordset
   Dim cn As New Connection
   Dim rs As New Recordset

   ' add error handler
   On Error GoTo HandleError
            
   ' connect to database
   cn.ConnectionString = "driver={SQL Server};server=FLAME;uid=sa;pwd=;database=pubs"
   cn.Open
   
   Set rs.ActiveConnection = cn
   rs.Source = "select title_id, title from titles"
   rs.CursorLocation = adUseClient
   
   rs.Open
   
   ' disconnect recordset
   Set rs.ActiveConnection = Nothing
   cn.Close
   
   Set getTitles = rs
   
' print out any error message
HandleError:
    If Err.Number <> 0 Then
       Err.Raise Err.Number, Err.Source, Err.Description
    End If

End Function

' getSpecificTitle
'
' get specific title and return as disconnected recordset
' also assign rs to Session object for update use
Public Function getSpecificTitle() As Recordset

   'Declare object variables for the database connection and recordset
   Dim cn As New Connection
   Dim rsTitles As Recordset
       
   ' get object context
   Dim objContext As ObjectContext
   Dim objRequest As Request
   Dim objSession As Session
   Dim objResponse As Response
   
   Set objContext = GetObjectContext()
   Set objRequest = objContext("Request")
   Set objSession = objContext("Session")
   Set objResponse = objContext("Response")
   
   ' add error handler
   On Error GoTo HandleError
   
     ' connect to database
   cn.ConnectionString = "driver={SQL Server};server=FLAME;uid=sa;pwd=;database=pubs"
   cn.Open
         
   ' setup record set - authors table
   Set rsTitles = New ADODB.Recordset
   
   Dim strCommand As String
   strCommand = "select * from titles where title_id = '"
   strCommand = strCommand & objRequest.Form("titleid") & "'"
   rsTitles.ActiveConnection = cn
   rsTitles.CursorType = adOpenKeyset
   rsTitles.LockType = adLockPessimistic
   rsTitles.CursorLocation = adUseClient
   
   rsTitles.Open strCommand
   
   ' disconnect recordset
   Set rsTitles.ActiveConnection = Nothing
   cn.Close
   
   ' assign to Session object
   ' only do this is ado15.reg has been used to set
   ' ADO objects to both threaded
   Set objSession.Contents("objtitle") = rsTitles
   
   Set getSpecificTitle = rsTitles

HandleError:
    If Err.Number <> 0 Then
       objContext.SetAbort
       Err.Raise Err.Number, Err.Source, Err.Description
    End If


End Function

' updateTitle
'
' updates title by accessing
' cached recordset from Session object
' and using this to test for differences

Public Sub updateTitle()

   'Declare object variables for the database connection and recordset
   Dim cn As Connection
   Dim rsTitles As Recordset
       
   ' get object context
   Dim objContext As ObjectContext
   Dim objRequest As Request
   Dim objSession As Session
   Dim objResponse As Response
   
   Set objContext = GetObjectContext()
   Set objRequest = objContext("Request")
   Set objSession = objContext("Session")
   Set objResponse = objContext("Response")
   
   ' add error handler
   On Error GoTo HandleError
       
    ' connect to database
   Set cn = objContext.CreateInstance("ADODB.Connection")
   cn.ConnectionString = "driver={SQL Server};server=FLAME;uid=sa;pwd=;database=pubs"
   cn.Open
      
   Set rsTitles = objSession.Contents("objtitle")
   
   ' access and set values
   Dim fld As Field
   For Each fld In rsTitles.Fields
     If CStr(fld.Value) <> objRequest.Form.Item(fld.Name) Then
       objResponse.Write (fld.Value & " ")
       fld.Value = objRequest.Form.Item(fld.Name)
       objResponse.Write (objRequest.Form.Item(fld.Name) & "<p>")
      End If
   Next fld
   
   ' reconnect to database connection and update
   Set rsTitles.ActiveConnection = cn
   rsTitles.Update
  
   Set objSession("objtitle") = Nothing
   
   cn.Close
   objContext.SetComplete

HandleError:
    If Err.Number <> 0 Then
       rsTitles.CancelUpdate
       Set objSession("objtitle") = Nothing
       objContext.SetAbort
       Err.Raise Err.Number, Err.Source, Err.Description
    End If

End Sub

