// objcontextmethods.cpp : Implementation of Cobjcontextmethods
#include "stdafx.h"
#include "MTSObjContext.h"
#include "objcontextmethods.h"
#import "embed.tlb" named_guids
#include "embed.h"

/////////////////////////////////////////////////////////////////////////////
// Cobjcontextmethods

HRESULT Cobjcontextmethods::Activate()
{
   HRESULT hr = S_OK;
   CComBSTR bstrObj;
   CComVariant vt;
   CComPtr<IGetContextProperties> pProps; //Context Properties

   IDispatch* piDispatch = NULL;

   // generated code
	hr = GetObjectContext(&m_spObjectContext);
   if (FAILED(hr))
      return hr;

   // add in code to get built-in objects
   
   // get Context Properties
   hr = m_spObjectContext->QueryInterface( IID_IGetContextProperties, 
               (void**)&pProps );
   if (FAILED(hr)) 
       return hr;

   // get Response property
   bstrObj = "Response";
   hr = pProps->GetProperty( bstrObj, &vt ) ;

   if (FAILED(hr))
       return hr;

   piDispatch = vt. pdispVal;
   hr = piDispatch->QueryInterface( IID_IResponse, 
                     (void**)&m_piResponse );


   return hr;
} 

BOOL Cobjcontextmethods::CanBePooled()
{
	return FALSE;
} 

void Cobjcontextmethods::Deactivate()
{
    CComVariant vtHeader("<H1>Unloading Response Object</H1>");
   m_piResponse->Write(vtHeader);
   

	// release pointer refs to built-in ASP objects
   m_piResponse.Release();

   // release ObjectContext - generated code
   m_spObjectContext.Release();
} 


STDMETHODIMP Cobjcontextmethods::objTestMTS(BSTR bstrHeader)
{
   HRESULT hr = S_OK;

   BOOL bResult;
   CComVariant vtResults;

   // check security
   bResult = m_spObjectContext->IsSecurityEnabled();
   if (bResult) 
      vtResults ="<p>Security is enabled";
   else 
      vtResults ="<p>Security is not enabled";
   m_piResponse->Write(vtResults);

   // check if in transaction
   bResult = m_spObjectContext->IsInTransaction();
   if (bResult) 
      vtResults ="<p>Component is in transaction";
   else 
      vtResults ="<p>Component is not in transaction";
   m_piResponse->Write(vtResults);

   // check if in role
   CComBSTR bstrRole("developer");
 
   // check for role membership
   hr = m_spObjectContext->IsCallerInRole(bstrRole,&bResult);
   if (SUCCEEDED(hr) && (bResult))
      vtResults ="<p>Client is in role 'developer'<p>";
   else 
      vtResults ="<p>Component is not in role 'developer'<p>";
   hr = m_piResponse->Write(vtResults);

   // mark component for deactivating, and set success or failure
   if (SUCCEEDED(hr))
      hr = m_spObjectContext->SetComplete();
   else
      hr = m_spObjectContext->SetAbort();

   // final write call, after set functions
   vtResults = bstrHeader;
   hr = m_piResponse->Write(vtResults);

   return hr;
}


STDMETHODIMP Cobjcontextmethods::testEmbed()
{
    HRESULT hr = S_OK;

	IObjectContext* pObjectContext = NULL;
   
   Iem* psc = NULL;
   // Get the object's ObjectContext.
   
   hr = GetObjectContext(&pObjectContext);
   // Use it to instantiate another object.
   
   hr = pObjectContext->CreateInstance(CLSID_em, IID_Iem, 
      (void **)&psc);

   hr = psc->test();

   return hr;
}
