// mytest.cpp : Implementation of Cmytest
#include "stdafx.h"
#include "MTSRequest.h"
#include "mytest.h"

/////////////////////////////////////////////////////////////////////////////
// Cmytest

HRESULT Cmytest::Activate()
{
   HRESULT hr = S_OK;
   CComBSTR bstrObj;
   CComVariant vt;
   CComPtr<IGetContextProperties> pProps; //Context Properties

   IDispatch* piDispatch = NULL;

   // generated code
	hr = GetObjectContext(&m_spObjectContext);
   if (FAILED(hr))
      return hr;

   // add in code to get built-in objects
   
   // get Context Properties
   hr = m_spObjectContext->QueryInterface( IID_IGetContextProperties, 
               (void**)&pProps );
   if (FAILED(hr)) 
       return hr;

   // get Response property
   bstrObj = "Response";
   hr = pProps->GetProperty( bstrObj, &vt ) ;

   if (FAILED(hr))
       return hr;

   piDispatch = vt. pdispVal;
   hr = piDispatch->QueryInterface( IID_IResponse, 
                     (void**)&m_piResponse );

   if (FAILED(hr))
       return hr;

   // get Request property
   bstrObj = "Request";
   hr = pProps->GetProperty( bstrObj, &vt ) ;

   if (FAILED(hr))
       return hr;

   piDispatch = vt. pdispVal;
   hr = piDispatch->QueryInterface( IID_IRequest, 
                     (void**)&m_piRequest );

   return hr;
} 

BOOL Cmytest::CanBePooled()
{
	return FALSE;
} 

void Cmytest::Deactivate()
{
   // release pointer refs to built-in ASP objects
   m_piResponse.Release();
   m_piRequest.Release();

   // release ObjectContext - generated code
   m_spObjectContext.Release();
} 


STDMETHODIMP Cmytest::thetest()
{
   HRESULT hr = S_OK;
   CComVariant vt;  
   IUnknown* pUnknown = NULL;
   IEnumVARIANT* pEnum = NULL;
   ULONG lValue;

    CComPtr<IRequestDictionary> piRequestVariables;
    hr = m_piRequest->get_Form(&piRequestVariables);

   // if failure, return
   if (FAILED(hr))
     return hr;

   // get enumerator object
   hr = piRequestVariables->get__NewEnum(&pUnknown);


   if (!FAILED(hr))
     {
     hr = pUnknown->QueryInterface( IID_IEnumVARIANT, 
                  (void**)&pEnum );
        if (FAILED(hr)) return hr;
   }
  

   // return the server variable and associated value
   // until the return value from Next is not S_OK
   while(S_OK == (pEnum->Next(1,&vt,&lValue))) {
      CComVariant vtValue;
       
      // write out the field name and an equal sign
      m_piResponse->Write(vt);
      vtValue = "=";
      m_piResponse->Write(vtValue);

      // get the field value and write out, followed by a paragraph
      piRequestVariables->get_Item(vt, &vtValue);
      m_piResponse->Write(vtValue);
      vt = "<p>";
      m_piResponse->Write(vt);
  }


  return hr;
}

STDMETHODIMP Cmytest::test2()
{
	// TODO: Add your implementation code here

   HRESULT hr = S_OK;

   IDispatch* pDispatch;
   IStringList* pList;
   CComVariant vt;  
   IUnknown* pUnknown = NULL;
   IEnumVARIANT* pEnum = NULL;
   ULONG lValue;
   CComBSTR bstrName = "MyValue";

   m_piRequest->get_Item(bstrName, &pDispatch);

   hr = pDispatch->QueryInterface( IID_IStringList,
                  (void**)&pList );

   // Get the item from the Contents collection
   hr = pList->get__NewEnum(&pUnknown);

   // cast to em interface object
   if (!FAILED(hr))
     {
     hr = pUnknown->QueryInterface( IID_IEnumVARIANT, 
                  (void**)&pEnum );
        if (FAILED(hr)) return hr;
   }
  
   // return the server variable and associated value
   while(S_OK == (pEnum->Next(1,&vt,&lValue))) {
      CComVariant vtValue;
      m_piResponse->Write(vt);
  }

   return hr;

}
