// mytest.cpp : Implementation of Cmytest
#include "stdafx.h"
#include "MTSSession.h"
#include "mytest.h"
#import "embed.tlb" named_guids   // use old naming convention
#include "embed.h"

/////////////////////////////////////////////////////////////////////////////
// Cmytest

HRESULT Cmytest::Activate()
{
   HRESULT hr = S_OK;
   CComBSTR bstrObj;
   CComVariant vt;
   CComPtr<IGetContextProperties> pProps; //Context Properties

   IDispatch* piDispatch = NULL;

   // generated code
	hr = GetObjectContext(&m_spObjectContext);
   if (FAILED(hr))
      return hr;

   // add in code to get built-in objects
   
   // get Context Properties
   hr = m_spObjectContext->QueryInterface( IID_IGetContextProperties, 
               (void**)&pProps );
   if (FAILED(hr)) 
       return hr;

   // get Response property
   bstrObj = "Response";
   hr = pProps->GetProperty( bstrObj, &vt ) ;

   if (FAILED(hr))
       return hr;

   piDispatch = vt. pdispVal;
   hr = piDispatch->QueryInterface( IID_IResponse, 
                     (void**)&m_piResponse );

   if (FAILED(hr))
       return hr;


   // get Session property
   bstrObj = "Session";
   hr = pProps->GetProperty( bstrObj, &vt ) ;

   if (FAILED(hr))
       return hr;

   piDispatch = vt. pdispVal;
   hr = piDispatch->QueryInterface( IID_ISessionObject, 
                     (void**)&m_piSession );


   return hr;
} 

BOOL Cmytest::CanBePooled()
{
   return false;
} 

void Cmytest::Deactivate()
{
   // release pointer refs to built-in ASP objects
   m_piResponse.Release();
   m_piSession.Release();

   // release ObjectContext - generated code
   m_spObjectContext.Release();
} 


STDMETHODIMP Cmytest::thetest()

{
   HRESULT hr = S_OK;

   CComVariant vtOut;
   long lTimeout;

   // get timeout, print, and modify
   m_piSession->get_Timeout(&lTimeout);

   CComVariant vtTimeout(lTimeout);
   m_piResponse->Write(vtTimeout);

   lTimeout = 40;

   m_piSession->put_Timeout(lTimeout);

   // access object from global.asa
   Iem* pEm = NULL;

   // Get the Contents Collection
	CComPtr<IVariantDictionary> piVariantVariables;
	hr = m_piSession->get_StaticObjects(&piVariantVariables);

   // if failure, return
   if (FAILED(hr))
     return hr;

   CComVariant vtIn(OLESTR("MyInfo"));

   // Get the item from the Contents collection
   hr = piVariantVariables->get_Item(vtIn, &vtOut);

   VariantChangeType(&vtOut, &vtOut, 0, VT_DISPATCH);

   // cast to em interface object
   if (!FAILED(hr))
     {
     IDispatch* pDispatch = V_DISPATCH(&vtOut);
       if ( pDispatch )
       {
        hr = pDispatch->QueryInterface( IID_Iem, 
                  (void**)&pEm );
        if (FAILED(hr)) return hr;
       }
   }

   hr = pEm->test();

   return hr;
}
