import com.ms.com.*;
import com.ms.wfc.data.*;
import com.ms.mtx.*;
import com.ms.asp.*;

/**
 * This class is designed to be packaged with a COM DLL output format.
 * The class has no standard entry points, other than the constructor.
 * Public methods will be exposed as methods on the default COM interface.
 * @com.register ( clsid=36F721A1-E698-11D2-87D3-204C4F4F5020, typelib=36F721A2-E698-11D2-87D3-204C4F4F5020 )
 */
public class tstado
{
    // response object
    IResponse iObjResponse = null;
    
    // connection object
    Connection conn = new Connection();
    
    // define connection event handler
    ConnectionEventHandler ceHandler = 
       new ConnectionEventHandler(this, "onConnectComplete");

   // connection event handler
   public void onConnectComplete(Object sender,ConnectionEvent e)
      {
      Variant vtConnection = new Variant();
    
      // check status
      if (e.adStatus == AdoEnums.EventStatus.ERRORSOCCURRED) {
         vtConnection.putString("Connection failed");   
         iObjResponse.Write(vtConnection);
         return;
         }
    
      // some other work
      Recordset rs = new Recordset();
      rs = conn.execute("select * from authors");
    
      String str;
      Variant vtOutput = new Variant();
      Field fld;
      rs.moveFirst();
      while (!rs.getEOF()) {
        str = rs.getFields().getItem("au_lname").getValue().toString();
        vtOutput.putString(str + "<br>");
        iObjResponse.Write(vtOutput);
        rs.moveNext();
        }
      return;   
   }
    
    
   // create connection, response object
   public void test() {
		
		// access Response object
      IGetContextProperties iObjProps;
      iObjProps = (IGetContextProperties)MTx.GetObjectContext();
      Variant vResponse = new Variant();
        
      // Get the Response object
      vResponse = iObjProps.GetProperty("Response");
      iObjResponse = (IResponse) vResponse.getDispatch();
		
	try
	{
         // add handler
         conn.addOnConnectComplete(ceHandler);

         // waiting...
         Variant vtMessage = new Variant("Waiting for connection...<p>");
         iObjResponse.Write(vtMessage);
            
         // open connection
         String str = "Provider=SQLOLEDB;database=pubs;Driver={SQL Server}";
         conn.open(str,"sa","");      
            
         vtMessage.putString("Finished with connection...");
         iObjResponse.Write(vtMessage);
            
         // other work ...
             
         conn.close();
    
         // remove event handler
         conn.removeOnConnectComplete(ceHandler);
         }
      catch( Exception e )
         {
         Variant vtError = new Variant(e.getLocalizedMessage());
         iObjResponse.Write(vtError);
         }
   }
}
